## cog 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3)

list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
include(VersioningUtils)
include(GNUInstallDirs)

set_project_version(0 4 0)

# Before making a release, the LT_VERSION string should be modified.
# The string is of the form C:R:A.
# - If interfaces have been changed or added, but binary compatibility has
#   been preserved, change to C+1:0:A+1
# - If binary compatibility has been broken (eg removed or changed interfaces)
#   change to C+1:0:0
# - If the interface is the same as the previous version, change to C:R+1:A
calculate_library_versions_from_libtool_triple(COGCORE 1 1 0)

project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
include(DistTargets)

set(COG_VERSION_EXTRA "")
if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
    set(COG_VERSION_EXTRA "+git")
    find_package(Git)
    if (GIT_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" rev-list --max-count=1 --abbrev-commit HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-${GIT_OUTPUT}")
        endif ()
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" status --porcelain
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-dirty")
        endif ()
        unset(GIT_STATUS)
        unset(GIT_OUTPUT)
    endif ()
    message(STATUS "Source tree revision: ${PROJECT_VERSION}${COG_VERSION_EXTRA}")
endif ()


option(COG_DBUS_SYSTEM_BUS "Expose remote control interface on system bus" OFF)
set(COG_DBUS_OWN_USER "" CACHE STRING
    "Additional user allowed to own the well-known name on the system bus")

option(COG_USE_WEBKITGTK "Use WebKitGTK+ instead of WPEWebKit" OFF)
option(COG_PLATFORM_FDO "Build the FDO platform module" ON)
option(COG_PLATFORM_DRM "Build the DRM platform module" OFF)
option(COG_BUILD_PROGRAMS "Build and install programs as well" ON)
set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
set(COG_HOME_URI "" CACHE STRING "Default home URI")

if (NOT COG_APPID OR COG_APPID STREQUAL "")
    if (COG_USE_WEBKITGTK)
        set(COG_DEFAULT_APPID com.igalia.CogGtk)
    else ()
        set(COG_DEFAULT_APPID com.igalia.Cog)
    endif ()
else ()
    set(COG_DEFAULT_APPID ${COG_APPID})
endif ()

if (COG_HOME_URI AND NOT COG_HOME_URI STREQUAL "")
    set(COG_DEFAULT_HOME_URI ${COG_HOME_URI})
endif ()

if (BUILD_SHARED_LIBS)
    set(COGCORE_COMPONENT "runtime")
else()
    set(COGCORE_COMPONENT "development")
endif()

add_definitions(-DCOG_INSIDE_COG__=1)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(PkgConfig)

# libcogcore
set(COGCORE_API_HEADERS
    core/cog.h
    core/cog-launcher.h
    core/cog-request-handler.h
    core/cog-directory-files-handler.h
    core/cog-shell.h
    core/cog-utils.h
    core/cog-webkit-utils.h
    ${CMAKE_CURRENT_BINARY_DIR}/cog-config.h
)
set(COGCORE_SOURCES
    core/cog-launcher.c
    core/cog-request-handler.c
    core/cog-directory-files-handler.c
    core/cog-utils.c
    core/cog-shell.c
    core/cog-webkit-utils.c
)

pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(SOUP REQUIRED libsoup-2.4)
if (COG_USE_WEBKITGTK)
    list(APPEND COGCORE_SOURCES core/cog-gtk-utils.c)
    pkg_check_modules(WEB_ENGINE REQUIRED webkit2gtk-4.0)
    if (WEB_ENGINE_VERSION VERSION_LESS 2.20.0)
        message(FATAL_ERROR "webkit2gtk-4.0 >= 2.20.0 is required.")
    endif ()
    add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=1)
else ()
    list(APPEND COGCORE_API_HEADERS core/cog-platform.h)
    list(APPEND COGCORE_SOURCES core/cog-platform.c)
    # There is no need to explicitly check wpe-1.0 here because it's a
    # dependency already specified in the wpe-webkit.pc file.
    pkg_check_modules(WEB_ENGINE REQUIRED wpe-webkit-1.0>=2.23.91)
    if ("${WEB_ENGINE_VERSION}" VERSION_GREATER "2.23")
        add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=1)
    else ()
        add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=0)
    endif ()
endif ()

include(CheckCCompilerFlag)
check_c_compiler_flag(-Wall HAS_WALL)
set(COGCORE_INCLUDE_DIRS ${WEB_ENGINE_INCLUDE_DIRS} ${SOUP_INCLUDE_DIRS})
set(COGCORE_CFLAGS ${WEB_ENGINE_CFLAGS_OTHER} ${SOUP_CFLAGS_OTHER})
if (HAS_WALL)
  set(COGCORE_CFLAGS ${WEB_ENGINE_CFLAGS_OTHER} ${SOUP_CFLAGS_OTHER} "-Wall")
endif ()
set(COGCORE_LDFLAGS ${WEB_ENGINE_LDFLAGS} ${SOUP_LDFLAGS})


if (COG_DBUS_SYSTEM_BUS)
    # Generate and install D-Bus policy configuration file.
    configure_file(dbus/policy.conf.in ${COG_DEFAULT_APPID}.conf @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${COG_DEFAULT_APPID}.conf
        DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d
        COMPONENT "runtime"
    )

    # Let the source code know that the option is enabled.
    add_definitions(-DCOG_DBUS_SYSTEM_BUS=1)
    add_definitions(-DCOG_DBUS_OWN_USER=\"${COG_DBUS_OWN_USER}\")
endif ()

add_library(cogcore SHARED ${COGCORE_SOURCES})
set_target_properties(cogcore PROPERTIES
    C_STANDARD 99
    VERSION ${COGCORE_VERSION}
    SOVERSION ${COGCORE_VERSION_MAJOR}
)
target_include_directories(cogcore PUBLIC core ${COGCORE_INCLUDE_DIRS})
target_link_libraries(cogcore ${COGCORE_LDFLAGS})
target_compile_options(cogcore
    PUBLIC ${COGCORE_CFLAGS}
    PRIVATE -DG_LOG_DOMAIN=\"Cog\"
)

if (COG_BUILD_PROGRAMS)
    add_executable(cog cog.c)
    set_property(TARGET cog PROPERTY C_STANDARD 99)
    if (HAS_WALL)
      target_compile_options(cog PUBLIC "-Wall")
    endif ()
    target_link_libraries(cog cogcore -ldl)

    add_executable(cogctl cogctl.c core/cog-utils.c)
    set_property(TARGET cogctl PROPERTY C_STANDARD 99)
    target_include_directories(cogctl PUBLIC ${GIO_INCLUDE_DIRS} ${SOUP_INCLUDE_DIRS})
    target_compile_options(cogctl PUBLIC ${GIO_CFLAGS_OTHER} ${SOUP_CFLAGS_OTHER})
    if (HAS_WALL)
      target_compile_options(cogctl PUBLIC "-Wall")
    endif ()
    target_link_libraries(cogctl ${GIO_LDFLAGS} ${SOUP_LDFLAGS})

    install(TARGETS cog cogctl
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT "runtime"
    )
endif ()


install(TARGETS cogcore
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT ${COGCORE_COMPONENT}
)
install(FILES ${COGCORE_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cog
    COMPONENT "development"
)

configure_file(core/cogcore.pc.in cogcore.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cogcore.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT "development"
)

# libcogplaform-fdo

if (COG_PLATFORM_FDO AND NOT COG_USE_WEBKITGTK)
    set(WAYLAND_1_10_OR_GREATER OFF)
    pkg_check_modules(WAYLAND REQUIRED wayland-client)
    if (NOT (WAYLAND_VERSION VERSION_LESS 1.10))
        set(WAYLAND_1_10_OR_GREATER ON)
    endif ()

    pkg_check_modules(COGPLATFORM_FDO_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 egl xkbcommon)
    pkg_check_modules(WAYLAND_EGL wayland-egl)

    set(COGPLATFORM_FDO_INCLUDE_DIRS
        ${COGPLATFORM_FDO_DEPS_INCLUDE_DIRS}
        ${WAYLAND_INCLUDE_DIRS}
        ${WAYLAND_EGL_INCLUDE_DIRS}
    )
    set(COGPLATFORM_FDO_CFLAGS
        ${COGPLATFORM_FDO_DEPS_CFLAGS_OTHER}
        ${WAYLAND_CFLAGS_OTHER}
        ${WAYLAND_EGL_CFLAGS_OTHER}
    )
    set(COGPLATFORM_FDO_LDFLAGS
        ${COGPLATFORM_FDO_DEPS_LDFLAGS}
        ${WAYLAND_LDFLAGS}
        ${WAYLAND_EGL_LDFLAGS}
    )

    add_library(cogplatform-fdo MODULE platform/cog-platform-fdo.c)
    set_property(TARGET cogplatform-fdo PROPERTY C_STANDARD 99)
    target_include_directories(cogplatform-fdo PUBLIC wayland ${COGPLATFORM_FDO_INCLUDE_DIRS})
    target_link_libraries(cogplatform-fdo cogcore ${COGPLATFORM_FDO_LDFLAGS})
    target_compile_options(cogplatform-fdo
        PUBLIC ${COGPLATFORM_FDO_CFLAGS}
        PRIVATE -DG_LOG_DOMAIN=\"Cog-FDO\"
    )

    find_package(WaylandProtocols REQUIRED)
    add_wayland_protocol(cogplatform-fdo CLIENT xdg-shell)
    add_wayland_protocol(cogplatform-fdo CLIENT fullscreen-shell-unstable-v1)

    install(TARGETS cogplatform-fdo
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT "runtime"
    )
endif ()  # !COG_USE_WEBKITGTK

# libcogplaform-drm-experimental

if (COG_PLATFORM_DRM AND NOT COG_USE_WEBKITGTK)
    pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev)

    set(COGPLATFORM_DRM_INCLUDE_DIRS
        ${COGPLATFORM_DRM_DEPS_INCLUDE_DIRS}
    )
    set(COGPLATFORM_DRM_CFLAGS
        ${COGPLATFORM_DRM_DEPS_CFLAGS_OTHER}
    )
    set(COGPLATFORM_DRM_LDFLAGS
        ${COGPLATFORM_DRM_DEPS_LDFLAGS}
    )

    add_library(cogplatform-drm-experimental MODULE platform/cog-platform-drm.c)
    set_property(TARGET cogplatform-drm-experimental PROPERTY C_STANDARD 99)
    target_include_directories(cogplatform-drm-experimental PUBLIC ${COGPLATFORM_DRM_INCLUDE_DIRS})
    target_compile_options(cogplatform-drm-experimental PUBLIC ${COGPLATFORM_DRM_CFLAGS})
    target_link_libraries(cogplatform-drm-experimental cogcore ${COGPLATFORM_DRM_LDFLAGS})

    install(TARGETS cogplatform-drm-experimental
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT "runtime"
    )
endif () # COG_PLATFORM_DRM AND NOT COG_USE_WEBKITGTK

configure_file(core/cog-config.h.in cog-config.h @ONLY)

=== debian/changelog ===
cog (0.4.0-2) unstable; urgency=medium

  * Set the debhelper compatibility level to 12:
    - Get rid of debian/compat.
    - Add build dependency on debhelper-compat.
  * Add upstream metadata file.

 -- Alberto Garcia <berto@igalia.com>  Mon, 03 Feb 2020 14:37:35 +0100

cog (0.4.0-1) experimental; urgency=medium

  * Initial release (Closes: #949476)

 -- Alberto Garcia <berto@igalia.com>  Sat, 25 Jan 2020 20:01:07 +0100

=== debian/control ===
Source: cog
Section: web
Priority: optional
Maintainer: Alberto Garcia <berto@igalia.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libwayland-dev,
               libwpebackend-fdo-1.0-dev,
               libwpewebkit-1.0-dev,
               wayland-protocols
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/Igalia/cog
Vcs-Browser: https://salsa.debian.org/berto/cog
Vcs-Git: https://salsa.debian.org/berto/cog.git

Package: cog
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Single-window web browser based on WPE WebKit
 Cog is a small, single-window web browser based on WPE WebKit.
 It provides no user interface and is suitable to be used as a web
 application container for embedded devices in kiosk mode.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
https://wpewebkit.org/releases/ cog-(.*).tar.xz

## cog 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include(VersioningUtils)
 include(GNUInstallDirs)
 
-set_project_version(0 4 0)
+set_project_version(0 6 0)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -13,7 +13,7 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 1 1 0)
+calculate_library_versions_from_libtool_triple(COGCORE 3 1 2)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
@@ -58,6 +58,9 @@
 option(COG_PLATFORM_FDO "Build the FDO platform module" ON)
 option(COG_PLATFORM_DRM "Build the DRM platform module" OFF)
 option(COG_BUILD_PROGRAMS "Build and install programs as well" ON)
+option(INSTALL_MAN_PAGES "Install the man(1) pages if COG_BUILD_PROGRAMS is enabled" ON)
+option(COG_WESTON_DIRECT_DISPLAY "Build direct display support for the FDO platform module" OFF)
+
 set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
 set(COG_HOME_URI "" CACHE STRING "Default home URI")
 
@@ -107,7 +110,7 @@
     core/cog-webkit-utils.c
 )
 
-pkg_check_modules(GIO REQUIRED gio-2.0)
+pkg_check_modules(GIO REQUIRED gio-2.0>=2.44)
 pkg_check_modules(SOUP REQUIRED libsoup-2.4)
 if (COG_USE_WEBKITGTK)
     list(APPEND COGCORE_SOURCES core/cog-gtk-utils.c)
@@ -127,6 +130,11 @@
     else ()
         add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=0)
     endif ()
+    if ("${WEB_ENGINE_VERSION}" VERSION_GREATER "2.27.3")
+        set(COG_IM_API_SUPPORTED ON)
+    else ()
+        set(COG_IM_API_SUPPORTED OFF)
+    endif ()
 endif ()
 
 include(CheckCCompilerFlag)
@@ -187,6 +195,12 @@
         DESTINATION ${CMAKE_INSTALL_BINDIR}
         COMPONENT "runtime"
     )
+    if (INSTALL_MAN_PAGES)
+        install(FILES data/cog.1 data/cogctl.1
+            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
+            COMPONENT "runtime"
+        )
+    endif ()
 endif ()
 
 
@@ -208,54 +222,82 @@
 # libcogplaform-fdo
 
 if (COG_PLATFORM_FDO AND NOT COG_USE_WEBKITGTK)
-    set(WAYLAND_1_10_OR_GREATER OFF)
-    pkg_check_modules(WAYLAND REQUIRED wayland-client)
-    if (NOT (WAYLAND_VERSION VERSION_LESS 1.10))
-        set(WAYLAND_1_10_OR_GREATER ON)
-    endif ()
-
-    pkg_check_modules(COGPLATFORM_FDO_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 egl xkbcommon)
-    pkg_check_modules(WAYLAND_EGL wayland-egl)
-
-    set(COGPLATFORM_FDO_INCLUDE_DIRS
-        ${COGPLATFORM_FDO_DEPS_INCLUDE_DIRS}
-        ${WAYLAND_INCLUDE_DIRS}
-        ${WAYLAND_EGL_INCLUDE_DIRS}
-    )
-    set(COGPLATFORM_FDO_CFLAGS
-        ${COGPLATFORM_FDO_DEPS_CFLAGS_OTHER}
-        ${WAYLAND_CFLAGS_OTHER}
-        ${WAYLAND_EGL_CFLAGS_OTHER}
-    )
-    set(COGPLATFORM_FDO_LDFLAGS
-        ${COGPLATFORM_FDO_DEPS_LDFLAGS}
-        ${WAYLAND_LDFLAGS}
-        ${WAYLAND_EGL_LDFLAGS}
-    )
-
     add_library(cogplatform-fdo MODULE platform/cog-platform-fdo.c)
+
     set_property(TARGET cogplatform-fdo PROPERTY C_STANDARD 99)
-    target_include_directories(cogplatform-fdo PUBLIC wayland ${COGPLATFORM_FDO_INCLUDE_DIRS})
-    target_link_libraries(cogplatform-fdo cogcore ${COGPLATFORM_FDO_LDFLAGS})
-    target_compile_options(cogplatform-fdo
-        PUBLIC ${COGPLATFORM_FDO_CFLAGS}
-        PRIVATE -DG_LOG_DOMAIN=\"Cog-FDO\"
-    )
+
+    target_compile_definitions(cogplatform-fdo PRIVATE G_LOG_DOMAIN=\"Cog-FDO\")
 
     find_package(WaylandProtocols REQUIRED)
     add_wayland_protocol(cogplatform-fdo CLIENT xdg-shell)
     add_wayland_protocol(cogplatform-fdo CLIENT fullscreen-shell-unstable-v1)
+    add_wayland_protocol(cogplatform-fdo CLIENT presentation-time)
+    add_wayland_protocol(cogplatform-fdo CLIENT linux-dmabuf-unstable-v1)
+
+    set(WAYLAND_1_10_OR_GREATER OFF)
+    pkg_check_modules(WAYLAND IMPORTED_TARGET REQUIRED wayland-client)
+    if (NOT (WAYLAND_VERSION VERSION_LESS 1.10))
+        set(WAYLAND_1_10_OR_GREATER ON)
+    endif ()
+
+    pkg_check_modules(COGPLATFORM_FDO_DEPS IMPORTED_TARGET REQUIRED
+        wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 egl xkbcommon)
+
+    target_link_libraries(cogplatform-fdo PRIVATE
+        cogcore PkgConfig::WAYLAND PkgConfig::COGPLATFORM_FDO_DEPS)
+
+    pkg_check_modules(WAYLAND_EGL IMPORTED_TARGET wayland-egl)
+    if (TARGET PkgConfig::WAYLAND_EGL)
+        target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::WAYLAND_EGL)
+    endif ()
 
     install(TARGETS cogplatform-fdo
         DESTINATION ${CMAKE_INSTALL_LIBDIR}
         COMPONENT "runtime"
     )
+
+    # Input methods extension.
+    if (COG_IM_API_SUPPORTED)
+        target_sources(cogplatform-fdo PRIVATE
+            platform/cog-im-context-fdo.c
+            platform/cog-im-context-fdo-v1.c
+        )
+        add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v1)
+        add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v3)
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=1)
+    else ()
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=0)
+    endif ()
+
+    # Direct video display extension.
+    find_path(WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT
+        NAMES wpe/extensions/video-plane-display-dmabuf.h
+        PATHS ${COGPLATFORM_FDO_DEPS_INCLUDE_DIRS}
+        NO_DEFAULT_PATH
+    )
+
+    if (COG_WESTON_DIRECT_DISPLAY AND WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT)
+        pkg_check_modules(LIBWESTON REQUIRED libweston-9-protocols)
+        pkg_get_variable(LIBWESTON_PKG_DATA_DIR libweston-9-protocols "pkgdatadir")
+        add_wayland_protocol(cogplatform-fdo CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-direct-display.xml")
+        add_wayland_protocol(cogplatform-fdo CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-content-protection.xml")
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=1)
+    else ()
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=0)
+    endif ()
+
+    # Optional pointer support
+    pkg_check_modules(WaylandCursor IMPORTED_TARGET wayland-cursor)
+    if (TARGET PkgConfig::WaylandCursor)
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_USE_WAYLAND_CURSOR)
+        target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::WaylandCursor)
+    endif ()
 endif ()  # !COG_USE_WEBKITGTK
 
-# libcogplaform-drm-experimental
+# libcogplaform-drm
 
 if (COG_PLATFORM_DRM AND NOT COG_USE_WEBKITGTK)
-    pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev)
+    pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev wayland-server)
 
     set(COGPLATFORM_DRM_INCLUDE_DIRS
         ${COGPLATFORM_DRM_DEPS_INCLUDE_DIRS}
@@ -267,13 +309,13 @@
         ${COGPLATFORM_DRM_DEPS_LDFLAGS}
     )
 
-    add_library(cogplatform-drm-experimental MODULE platform/cog-platform-drm.c)
-    set_property(TARGET cogplatform-drm-experimental PROPERTY C_STANDARD 99)
-    target_include_directories(cogplatform-drm-experimental PUBLIC ${COGPLATFORM_DRM_INCLUDE_DIRS})
-    target_compile_options(cogplatform-drm-experimental PUBLIC ${COGPLATFORM_DRM_CFLAGS})
-    target_link_libraries(cogplatform-drm-experimental cogcore ${COGPLATFORM_DRM_LDFLAGS})
-
-    install(TARGETS cogplatform-drm-experimental
+    add_library(cogplatform-drm MODULE platform/cog-platform-drm.c)
+    set_property(TARGET cogplatform-drm PROPERTY C_STANDARD 99)
+    target_include_directories(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_INCLUDE_DIRS})
+    target_compile_options(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_CFLAGS})
+    target_link_libraries(cogplatform-drm cogcore ${COGPLATFORM_DRM_LDFLAGS})
+
+    install(TARGETS cogplatform-drm
         DESTINATION ${CMAKE_INSTALL_LIBDIR}
         COMPONENT "runtime"
     )

=== debian/changelog ===
cog (0.6.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years.
  * Upstream provides the manpages now, add them to debian/install and
    remove the ones shipped in the debian directory.
  * Add uninstalled development files to debian/not-installed so
    dh_misssing does not complain about them.

 -- Alberto Garcia <berto@igalia.com>  Mon, 30 Mar 2020 14:09:27 +0200

## cog 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 include(VersioningUtils)
 include(GNUInstallDirs)
 
-set_project_version(0 6 0)
+set_project_version(0 8 0)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -13,7 +13,7 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 3 1 2)
+calculate_library_versions_from_libtool_triple(COGCORE 4 2 3)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
@@ -135,6 +135,11 @@
     else ()
         set(COG_IM_API_SUPPORTED OFF)
     endif ()
+    if (COG_PLATFORM_FDO AND "${WEB_ENGINE_VERSION}" VERSION_GREATER "2.27.3")
+        set(COG_FDO_WIDGETS_SUPPORTED ON)
+    else ()
+        set(COG_FDO_WIDGETS_SUPPORTED OFF)
+    endif ()
 endif ()
 
 include(CheckCCompilerFlag)
@@ -264,9 +269,29 @@
         )
         add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v1)
         add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v3)
+        target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=1)
+        if (COG_BUILD_PROGRAMS)
+            target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=1)
+        endif ()
         target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=1)
     else ()
+        target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=0)
+        if (COG_BUILD_PROGRAMS)
+            target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=0)
+        endif ()
         target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=0)
+    endif ()
+
+    if (COG_FDO_WIDGETS_SUPPORTED)
+        pkg_check_modules(CAIRO IMPORTED_TARGET cairo)
+        target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::CAIRO)
+        target_sources(cogplatform-fdo PRIVATE
+            platform/cog-popup-menu-fdo.c
+            platform/os-compatibility.c
+        )
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=1)
+    else ()
+        target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=0)
     endif ()
 
     # Direct video display extension.
@@ -300,25 +325,3 @@
     pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev wayland-server)
 
     set(COGPLATFORM_DRM_INCLUDE_DIRS
-        ${COGPLATFORM_DRM_DEPS_INCLUDE_DIRS}
-    )
-    set(COGPLATFORM_DRM_CFLAGS
-        ${COGPLATFORM_DRM_DEPS_CFLAGS_OTHER}
-    )
-    set(COGPLATFORM_DRM_LDFLAGS
-        ${COGPLATFORM_DRM_DEPS_LDFLAGS}
-    )
-
-    add_library(cogplatform-drm MODULE platform/cog-platform-drm.c)
-    set_property(TARGET cogplatform-drm PROPERTY C_STANDARD 99)
-    target_include_directories(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_INCLUDE_DIRS})
-    target_compile_options(cogplatform-drm PUBLIC ${COGPLATFORM_DRM_CFLAGS})
-    target_link_libraries(cogplatform-drm cogcore ${COGPLATFORM_DRM_LDFLAGS})
-
-    install(TARGETS cogplatform-drm
-        DESTINATION ${CMAKE_INSTALL_LIBDIR}
-        COMPONENT "runtime"
-    )
-endif () # COG_PLATFORM_DRM AND NOT COG_USE_WEBKITGTK
-
-configure_file(core/cog-config.h.in cog-config.h @ONLY)

=== debian/changelog ===
cog (0.8.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/use-fdo-backend.patch:
    - Refresh patch.
  * debian/control:
    - Add build dependency on libcairo-dev.

 -- Alberto Garcia <berto@igalia.com>  Mon, 14 Sep 2020 17:24:21 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Alberto Garcia <berto@igalia.com>
 Build-Depends: debhelper-compat (= 12),
                cmake,
+               libcairo-dev,
                libwayland-dev,
                libwpebackend-fdo-1.0-dev,
                libwpewebkit-1.0-dev,

## cog 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,8 @@
 
 list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
 include(VersioningUtils)
-include(GNUInstallDirs)
-
-set_project_version(0 8 0)
+
+set_project_version(0 8 1)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -13,10 +12,11 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 4 2 3)
+calculate_library_versions_from_libtool_triple(COGCORE 4 3 3)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
+include(GNUInstallDirs)
 
 set(COG_VERSION_EXTRA "")
 if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
@@ -294,14 +294,16 @@
         target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=0)
     endif ()
 
-    # Direct video display extension.
-    find_path(WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT
-        NAMES wpe/extensions/video-plane-display-dmabuf.h
-        PATHS ${COGPLATFORM_FDO_DEPS_INCLUDE_DIRS}
-        NO_DEFAULT_PATH
-    )
-
-    if (COG_WESTON_DIRECT_DISPLAY AND WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT)
+    if (COG_WESTON_DIRECT_DISPLAY)
+
+        # Direct video display extension.
+        find_path(WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT
+            NAMES wpe/extensions/video-plane-display-dmabuf.h
+            PATHS ${WpeFDO_INCLUDE_DIRS}
+            NO_DEFAULT_PATH
+            REQUIRED
+        )
+
         pkg_check_modules(LIBWESTON REQUIRED libweston-9-protocols)
         pkg_get_variable(LIBWESTON_PKG_DATA_DIR libweston-9-protocols "pkgdatadir")
         add_wayland_protocol(cogplatform-fdo CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-direct-display.xml")
@@ -325,3 +327,5 @@
     pkg_check_modules(COGPLATFORM_DRM_DEPS REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 libdrm>=2.4.71 gbm>=13.0 egl libinput libudev wayland-server)
 
     set(COGPLATFORM_DRM_INCLUDE_DIRS
+        ${COGPLATFORM_DRM_DEPS_INCLUDE_DIRS}
+    )

=== debian/changelog ===
cog (0.8.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Update copyright years.
  * debian/watch:
    - Set version to 4 (fixes older-debian-watch-file-standard).
  * debian/control:
    - Update Standards-Version to 4.5.1 (no changes).

 -- Alberto Garcia <berto@igalia.com>  Wed, 24 Feb 2021 10:57:15 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libwpebackend-fdo-1.0-dev,
                libwpewebkit-1.0-dev,
                wayland-protocols
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/Igalia/cog
 Vcs-Browser: https://salsa.debian.org/berto/cog

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://wpewebkit.org/releases/ cog-(.*).tar.xz

## cog 0.10.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3)

list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
include(VersioningUtils)

set_project_version(0 10 0)

# Before making a release, the LT_VERSION string should be modified.
# The string is of the form C:R:A.
# - If interfaces have been changed or added, but binary compatibility has
#   been preserved, change to C+1:0:A+1
# - If binary compatibility has been broken (eg removed or changed interfaces)
#   change to C+1:0:0
# - If the interface is the same as the previous version, change to C:R+1:A
calculate_library_versions_from_libtool_triple(COGCORE 5 2 4)

project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
include(DistTargets)
include(GNUInstallDirs)

set(COG_VERSION_EXTRA "")
if (IS_DIRECTORY "${CMAKE_SOURCE_DIR}/.git")
    set(COG_VERSION_EXTRA "+git")
    find_package(Git)
    if (GIT_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" rev-list --max-count=1 --abbrev-commit HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-${GIT_OUTPUT}")
        endif ()
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" status --porcelain
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            RESULT_VARIABLE GIT_STATUS
            OUTPUT_VARIABLE GIT_OUTPUT
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_QUIET)
        if (${GIT_STATUS} EQUAL 0 AND GIT_OUTPUT)
            set(COG_VERSION_EXTRA "${COG_VERSION_EXTRA}-dirty")
        endif ()
        unset(GIT_STATUS)
        unset(GIT_OUTPUT)
    endif ()
    message(STATUS "Source tree revision: ${PROJECT_VERSION}${COG_VERSION_EXTRA}")
endif ()


option(COG_DBUS_SYSTEM_BUS "Expose remote control interface on system bus" OFF)
set(COG_DBUS_OWN_USER "" CACHE STRING
    "Additional user allowed to own the well-known name on the system bus")

option(COG_PLATFORM_FDO "Build the FDO platform module" ON)
option(COG_PLATFORM_DRM "Build the DRM platform module" ON)
option(COG_PLATFORM_X11 "Build the X11 platform module" OFF)
option(COG_PLATFORM_GTK4 "Build the GTK4 platform module" OFF)

option(COG_BUILD_PROGRAMS "Build and install programs as well" ON)
option(INSTALL_MAN_PAGES "Install the man(1) pages if COG_BUILD_PROGRAMS is enabled" ON)
option(COG_WESTON_DIRECT_DISPLAY "Build direct display support for the FDO platform module" OFF)
option(BUILD_DOCS "Build the documentation" OFF)

set(COG_APPID "" CACHE STRING "Default GApplication unique identifier")
set(COG_HOME_URI "" CACHE STRING "Default home URI")

if (NOT COG_APPID OR COG_APPID STREQUAL "")
    set(COG_DEFAULT_APPID com.igalia.Cog)
else ()
    set(COG_DEFAULT_APPID ${COG_APPID})
endif ()

if (COG_HOME_URI AND NOT COG_HOME_URI STREQUAL "")
    set(COG_DEFAULT_HOME_URI ${COG_HOME_URI})
endif ()

if (BUILD_SHARED_LIBS)
    set(COGCORE_COMPONENT "runtime")
else()
    set(COGCORE_COMPONENT "development")
endif()

add_definitions(-DCOG_INSIDE_COG__=1)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

find_package(PkgConfig)

# libcogcore
set(COGCORE_API_HEADERS
    core/cog.h
    core/cog-launcher.h
    core/cog-request-handler.h
    core/cog-directory-files-handler.h
    core/cog-prefix-routes-handler.h
    core/cog-shell.h
    core/cog-utils.h
    core/cog-webkit-utils.h
    core/cog-platform.h
    ${CMAKE_CURRENT_BINARY_DIR}/cog-config.h
)
set(COGCORE_SOURCES
    core/cog-launcher.c
    core/cog-request-handler.c
    core/cog-directory-files-handler.c
    core/cog-prefix-routes-handler.c
    core/cog-utils.c
    core/cog-shell.c
    core/cog-webkit-utils.c
    core/cog-platform.c
)

pkg_check_modules(GIO IMPORTED_TARGET REQUIRED gio-2.0>=2.44)
pkg_check_modules(SOUP IMPORTED_TARGET REQUIRED libsoup-2.4)

# There is no need to explicitly check wpe-1.0 here because it's a
# dependency already specified in the wpe-webkit.pc file.
pkg_check_modules(WEB_ENGINE IMPORTED_TARGET REQUIRED wpe-webkit-1.0>=2.23.91)
if ("${WEB_ENGINE_VERSION}" VERSION_GREATER "2.23")
    add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=1)
else ()
    add_definitions(-DCOG_BG_COLOR_API_SUPPORTED=0)
endif ()
if ("${WEB_ENGINE_VERSION}" VERSION_GREATER "2.27.3")
    set(COG_IM_API_SUPPORTED ON)
else ()
    set(COG_IM_API_SUPPORTED OFF)
endif ()
if (COG_PLATFORM_FDO AND "${WEB_ENGINE_VERSION}" VERSION_GREATER "2.27.3")
    set(COG_FDO_WIDGETS_SUPPORTED ON)
else ()
    set(COG_FDO_WIDGETS_SUPPORTED OFF)
endif ()

include(CheckCCompilerFlag)
check_c_compiler_flag(-Wall HAS_WALL)


if (COG_DBUS_SYSTEM_BUS)
    # Generate and install D-Bus policy configuration file.
    configure_file(dbus/policy.conf.in ${COG_DEFAULT_APPID}.conf @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${COG_DEFAULT_APPID}.conf
        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/system.d
        COMPONENT "runtime"
    )

    # Let the source code know that the option is enabled.
    add_definitions(-DCOG_DBUS_SYSTEM_BUS=1)
    add_definitions(-DCOG_DBUS_OWN_USER=\"${COG_DBUS_OWN_USER}\")
endif ()

add_library(cogcore SHARED ${COGCORE_SOURCES} ${COGCORE_API_HEADERS})
set_target_properties(cogcore PROPERTIES
    C_STANDARD 99
    VERSION ${COGCORE_VERSION}
    SOVERSION ${COGCORE_VERSION_MAJOR}
)
target_link_libraries(cogcore PkgConfig::WEB_ENGINE PkgConfig::SOUP)
target_compile_definitions(cogcore PRIVATE G_LOG_DOMAIN=\"Cog-Core\")
if (HAS_WALL)
    target_compile_options(cogcore PUBLIC -Wall)
endif ()

if (COG_BUILD_PROGRAMS)
    add_executable(cog cog.c)
    set_property(TARGET cog PROPERTY C_STANDARD 99)
    if (HAS_WALL)
      target_compile_options(cog PUBLIC "-Wall")
    endif ()
    target_compile_definitions(cog PRIVATE G_LOG_DOMAIN=\"Cog\")
    target_link_libraries(cog cogcore -ldl)

    add_executable(cogctl cogctl.c core/cog-utils.c)
    set_property(TARGET cogctl PROPERTY C_STANDARD 99)
    target_compile_definitions(cogctl PRIVATE G_LOG_DOMAIN=\"Cog-Control\")
    if (HAS_WALL)
      target_compile_options(cogctl PUBLIC "-Wall")
    endif ()
    target_link_libraries(cogctl PkgConfig::GIO PkgConfig::SOUP)

    install(TARGETS cog cogctl
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT "runtime"
    )
    if (INSTALL_MAN_PAGES)
        install(FILES data/cog.1 data/cogctl.1
            DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
            COMPONENT "runtime"
        )
    endif ()
endif ()


install(TARGETS cogcore
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT ${COGCORE_COMPONENT}
)
install(FILES ${COGCORE_API_HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cog
    COMPONENT "development"
)

configure_file(core/cog-config.h.in cog-config.h @ONLY)
configure_file(core/cogcore.pc.in cogcore.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cogcore.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT "development"
)

if (BUILD_DOCS)
    add_subdirectory(docs)
endif ()

add_subdirectory(platform/headless)
if (COG_PLATFORM_FDO)
    add_subdirectory(platform/fdo)
endif ()
if (COG_PLATFORM_DRM)
    add_subdirectory(platform/drm)
endif ()
if (COG_PLATFORM_X11)
    add_subdirectory(platform/x11)
endif ()
if (COG_PLATFORM_GTK4)
    add_subdirectory(platform/gtk4)
endif ()

=== docs/CMakeLists.txt ===
find_package(GObjectIntrospection REQUIRED)
find_program(GI_DOCGEN
    NAMES gi-docgen gi-docgen.py
    HINTS "${CMAKE_SOURCE_DIR}/gi-docgen"
    DOC "Path to the gi-docgen program"
    REQUIRED
)

message(STATUS "Using g-ir-scanner: ${INTROSPECTION_SCANNER}")
message(STATUS "Using gi-docgen: ${GI_DOCGEN}")

configure_file(cog.toml.in cog.toml @ONLY)

# TODO: Probably should be moved somewhere else, and use the API
#       version string for other things, e.g. the library name.
set(COGCORE_API_VERSION "${PROJECT_VERSION_MAJOR}.0")
set(COGCORE_GIR_NAME "Cog-${COGCORE_API_VERSION}")
set(COGCORE_GIR "${CMAKE_CURRENT_BINARY_DIR}/${COGCORE_GIR_NAME}.gir")

function (get_target_doc_sources target varname)
    set(result "")
    get_property(sources TARGET ${target} PROPERTY SOURCES)
    get_property(srcdir TARGET ${target} PROPERTY SOURCE_DIR)
    foreach (src IN LISTS sources)
        get_filename_component(src "${src}" REALPATH BASE_DIR "${srcdir}")
        get_property(isobject SOURCE "${src}" PROPERTY EXTERNAL_OBJECT)
        get_property(location SOURCE "${src}" PROPERTY LOCATION)
        if (NOT isobject)
            list(APPEND result "${location}")
        endif ()
    endforeach ()
    set(${varname} ${result} PARENT_SCOPE)
endfunction ()

function (get_target_include_flags target varname)
    set(result "")
    get_property(dirs TARGET ${target} PROPERTY INCLUDE_DIRECTORIES)
    foreach (dir IN LISTS dirs)
        list(APPEND result "-I${dir}")
    endforeach ()
    set(${varname} ${result} PARENT_SCOPE)
endfunction ()

get_target_doc_sources(cogcore COGCORE_DOC_SOURCES)
get_target_include_flags(cogcore COGCORE_DOC_IFLAGS)

add_custom_command(
    OUTPUT "${COGCORE_GIR}"
    COMMENT "Generating ${COGCORE_GIR_NAME}.gir ..."
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    DEPENDS ${COGCORE_DOC_SOURCES}
    VERBATIM
    COMMAND CC="${CMAKE_C_COMPILER}"
        ${INTROSPECTION_SCANNER}
        --output=${COGCORE_GIR}
        --warn-all
        --no-libtool
        --library=$<TARGET_FILE_BASE_NAME:cogcore>
        --library-path=$<TARGET_FILE_DIR:cogcore>
        --nsversion=${COGCORE_API_VERSION}
        --c-include=cog/cog.h
        --namespace=Cog
        --identifier-prefix=Cog
        --symbol-prefix=cog
        --pkg-export=cogcore
        --pkg=wpe-webkit-1.0
        --pkg=gobject-2.0
        --pkg=gio-2.0
        --pkg=glib-2.0
        ${COGCORE_DOC_IFLAGS}
        ${COGCORE_DOC_SOURCES}
)

file(GLOB COGCORE_DOC_MARKDOWN_SOURCES *.md)

add_custom_command(
    OUTPUT html/index.html
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
    COMMENT "Generating documentation for ${COGCORE_GIR_NAME} ..."
    DEPENDS cog.toml ${COGCORE_GIR} ${COGCORE_DOC_MARKDOWN_SOURCES}
    VERBATIM
    COMMAND "${GI_DOCGEN}" generate --quiet --no-namespace-dir
        --content-dir ${CMAKE_CURRENT_SOURCE_DIR}
        --output-dir ${CMAKE_CURRENT_BINARY_DIR}/html
        --config ${CMAKE_CURRENT_BINARY_DIR}/cog.toml
        ${COGCORE_GIR}
)

add_custom_target(doc ALL DEPENDS html/index.html)

=== platform/drm/CMakeLists.txt ===
# libcogplatform-drm

pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.3.1)
pkg_check_modules(LibDRM IMPORTED_TARGET REQUIRED libdrm>=2.4.71)
pkg_check_modules(LibGBM IMPORTED_TARGET REQUIRED gbm>=13.0)
pkg_check_modules(LibInput IMPORTED_TARGET REQUIRED libinput)
pkg_check_modules(LibUdev IMPORTED_TARGET REQUIRED libudev)
pkg_check_modules(WaylandServer IMPORTED_TARGET REQUIRED wayland-server)

add_library(cogplatform-drm MODULE
    cog-platform-drm.c
    kms.c
    cursor-drm.c
)
set_target_properties(cogplatform-fdo PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)
target_compile_definitions(cogplatform-drm PRIVATE G_LOG_DOMAIN=\"Cog-DRM\")
target_link_libraries(cogplatform-drm PRIVATE
    cogcore
    PkgConfig::EGL
    PkgConfig::LibDRM
    PkgConfig::LibGBM
    PkgConfig::LibInput
    PkgConfig::LibUdev
    PkgConfig::WEB_ENGINE
    PkgConfig::WaylandServer
    PkgConfig::WpeFDO
)

install(TARGETS cogplatform-drm
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime"
)

=== platform/fdo/CMakeLists.txt ===
# libcogplatform-fdo

add_library(cogplatform-fdo MODULE cog-platform-fdo.c)
set_target_properties(cogplatform-fdo PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)
target_compile_definitions(cogplatform-fdo PRIVATE G_LOG_DOMAIN=\"Cog-FDO\")

find_package(WaylandProtocols REQUIRED)
add_wayland_protocol(cogplatform-fdo CLIENT xdg-shell)
add_wayland_protocol(cogplatform-fdo CLIENT fullscreen-shell-unstable-v1)
add_wayland_protocol(cogplatform-fdo CLIENT presentation-time)
add_wayland_protocol(cogplatform-fdo CLIENT linux-dmabuf-unstable-v1)

pkg_check_modules(WAYLAND IMPORTED_TARGET REQUIRED wayland-client)
pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.3.1)
pkg_check_modules(EGL IMPORTED_TARGET REQUIRED egl)
pkg_check_modules(XkbCommon IMPORTED_TARGET REQUIRED xkbcommon)

target_link_libraries(cogplatform-fdo PRIVATE
    cogcore
    PkgConfig::EGL
    PkgConfig::WAYLAND
    PkgConfig::WEB_ENGINE
    PkgConfig::WpeFDO
)

pkg_check_modules(WAYLAND_EGL IMPORTED_TARGET wayland-egl)
if (TARGET PkgConfig::WAYLAND_EGL)
    target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::WAYLAND_EGL)
endif ()

install(TARGETS cogplatform-fdo
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime"
)

# Input methods extension.
if (COG_IM_API_SUPPORTED)
    target_sources(cogplatform-fdo PRIVATE
        cog-im-context-fdo.c
        cog-im-context-fdo-v1.c
    )
    add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v1)
    add_wayland_protocol(cogplatform-fdo CLIENT text-input-unstable-v3)
    target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=1)
    if (COG_BUILD_PROGRAMS)
        target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=1)
    endif ()
    target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=1)
else ()
    target_compile_options(cogcore PRIVATE -DCOG_IM_API_SUPPORTED=0)
    if (COG_BUILD_PROGRAMS)
        target_compile_options(cog PRIVATE -DCOG_IM_API_SUPPORTED=0)
    endif ()
    target_compile_definitions(cogplatform-fdo PRIVATE COG_IM_API_SUPPORTED=0)
endif ()

if (COG_FDO_WIDGETS_SUPPORTED)
    pkg_check_modules(CAIRO IMPORTED_TARGET cairo)
    target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::CAIRO)
    target_sources(cogplatform-fdo PRIVATE
        cog-popup-menu-fdo.c
        os-compatibility.c
    )
    target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=1)
else ()
    target_compile_definitions(cogplatform-fdo PRIVATE COG_FDO_WIDGETS_SUPPORTED=0)
endif ()

if (COG_WESTON_DIRECT_DISPLAY)

    # Direct video display extension.
    find_path(WPEBACKEND_FDO_HAS_VIDEO_PLANE_DISPLAY_DMABUF_EXT
        NAMES wpe/extensions/video-plane-display-dmabuf.h
        PATHS ${WpeFDO_INCLUDE_DIRS}
        NO_DEFAULT_PATH
        REQUIRED
    )

    pkg_check_modules(LIBWESTON REQUIRED libweston-9-protocols)
    pkg_get_variable(LIBWESTON_PKG_DATA_DIR libweston-9-protocols "pkgdatadir")
    add_wayland_protocol(cogplatform-fdo CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-direct-display.xml")
    add_wayland_protocol(cogplatform-fdo CLIENT "${LIBWESTON_PKG_DATA_DIR}/weston-content-protection.xml")
    target_compile_definitions(cogplatform-fdo PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=1)
else ()
    target_compile_definitions(cogplatform-fdo PRIVATE COG_ENABLE_WESTON_DIRECT_DISPLAY=0)
endif ()

# Optional pointer support
pkg_check_modules(WaylandCursor IMPORTED_TARGET wayland-cursor)
if (TARGET PkgConfig::WaylandCursor)
    target_compile_definitions(cogplatform-fdo PRIVATE COG_USE_WAYLAND_CURSOR)
    target_link_libraries(cogplatform-fdo PRIVATE PkgConfig::WaylandCursor)
endif ()

=== platform/gtk4/CMakeLists.txt ===
pkg_check_modules(COGPLATFORM_GTK4_DEPS REQUIRED
    IMPORTED_TARGET gtk4 wpebackend-fdo-1.0)
add_library(cogplatform-gtk4 MODULE
    cog-platform-gtk4.c
    cog-gtk-settings-dialog.c
    cog-gtk-settings-cell-renderer-variant.c)
target_link_libraries(cogplatform-gtk4 PRIVATE
    PkgConfig::COGPLATFORM_GTK4_DEPS
    PkgConfig::WEB_ENGINE
)
set_target_properties(cogplatform-gtk4 PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
target_compile_options(cogplatform-gtk4
    PRIVATE -DG_LOG_DOMAIN=\"Cog-Gtk4\")
install(TARGETS cogplatform-gtk4
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime")

=== platform/headless/CMakeLists.txt ===

pkg_check_modules(WpeFDO IMPORTED_TARGET REQUIRED wpebackend-fdo-1.0>=1.8.0)
add_library(cogplatform-headless MODULE cog-platform-headless.c)
set_target_properties(cogplatform-headless PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

target_compile_definitions(cogplatform-headless PRIVATE G_LOG_DOMAIN=\"Cog-HEADLESS\")
target_link_libraries(cogplatform-headless PRIVATE
    cogcore
    PkgConfig::WpeFDO
)

install(TARGETS cogplatform-headless
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime"
)

=== platform/x11/CMakeLists.txt ===
# libcogplaform-x11

pkg_check_modules(COGPLATFORM_X11_DEPS IMPORTED_TARGET
    REQUIRED wpe-webkit-1.0>=2.24.0 wpebackend-fdo-1.0>=1.3.1 egl xcb xkbcommon-x11)

add_library(cogplatform-x11 MODULE cog-platform-x11.c)
set_target_properties(cogplatform-x11 PROPERTIES
    C_STANDARD 99
    LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)
target_compile_definitions(cogplatform-x11 PRIVATE G_LOG_DOMAIN=\"Cog-X11\")
target_link_libraries(cogplatform-x11 PRIVATE cogcore PkgConfig::COGPLATFORM_X11_DEPS)

install(TARGETS cogplatform-x11
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT "runtime"
)

=== debian/changelog ===
cog (0.10.0-2) unstable; urgency=medium

  * debian/control:
    - Build with libwpebackend-fdo-1.0-dev 1.10.0. This enables SHM buffer
      exports.

 -- Alberto Garcia <berto@igalia.com>  Wed, 16 Jun 2021 15:31:16 +0200

cog (0.10.0-1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Add build dependencies on libdrm-dev, libgbm-dev and libinput-dev.
  * debian/install:
    - Install all platform plugins (this version builds two new ones: drm
      and headless).
  * debian/cog.lintian-overrides:
    - Override sharedobject-in-library-directory-missing-soname in all
      plugins
    - Override library-not-linked-against-libc in the headless plugin
      (this is a false positive, this plugin does not use libc symbols)
  * Drop use-fdo-backend.patch.

 -- Alberto Garcia <berto@igalia.com>  Tue, 18 May 2021 23:25:25 +0200

## cog 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake")
 include(VersioningUtils)
 
-set_project_version(0 10 0)
+set_project_version(0 10 1)
 
 # Before making a release, the LT_VERSION string should be modified.
 # The string is of the form C:R:A.
@@ -12,7 +12,7 @@
 # - If binary compatibility has been broken (eg removed or changed interfaces)
 #   change to C+1:0:0
 # - If the interface is the same as the previous version, change to C:R+1:A
-calculate_library_versions_from_libtool_triple(COGCORE 5 2 4)
+calculate_library_versions_from_libtool_triple(COGCORE 5 3 4)
 
 project(cog VERSION "${PROJECT_VERSION}" LANGUAGES C)
 include(DistTargets)
@@ -54,6 +54,7 @@
 set(COG_DBUS_OWN_USER "" CACHE STRING
     "Additional user allowed to own the well-known name on the system bus")
 
+option(COG_PLATFORM_HEADLESS "Build the headless platform module" ON)
 option(COG_PLATFORM_FDO "Build the FDO platform module" ON)
 option(COG_PLATFORM_DRM "Build the DRM platform module" ON)
 option(COG_PLATFORM_X11 "Build the X11 platform module" OFF)
@@ -215,7 +216,9 @@
     add_subdirectory(docs)
 endif ()
 
-add_subdirectory(platform/headless)
+if (COG_PLATFORM_HEADLESS)
+    add_subdirectory(platform/headless)
+endif ()
 if (COG_PLATFORM_FDO)
     add_subdirectory(platform/fdo)
 endif ()

=== platform/drm/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
     kms.c
     cursor-drm.c
 )
-set_target_properties(cogplatform-fdo PROPERTIES
+set_target_properties(cogplatform-drm PROPERTIES
     C_STANDARD 99
     LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )

=== debian/changelog ===
cog (0.10.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alberto Garcia <berto@igalia.com>  Wed, 08 Sep 2021 09:33:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,11 @@
 Build-Depends: debhelper-compat (= 12),
                cmake,
                libcairo-dev,
+               libdrm-dev,
+               libgbm-dev,
+               libinput-dev,
                libwayland-dev,
-               libwpebackend-fdo-1.0-dev,
+               libwpebackend-fdo-1.0-dev (>= 1.10.0),
                libwpewebkit-1.0-dev,
                wayland-protocols
 Standards-Version: 4.5.1
